//
//  DBManager.m
//  FuzzySearch
//
//  Created by GM on 16/6/23.
//  Copyright © 2016年 GM. All rights reserved.
//

#import "DBManager.h"
#import "FMDB.h"
#import "NSString+category.h"

@implementation person
@end

@interface DBManager ()
@property(nonatomic,strong)FMDatabaseQueue *queue;
@end
@implementation DBManager

+(DBManager *)shareDBManager
{
    static DBManager *shareDBManager = nil;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        @synchronized(self){
            shareDBManager = [[self alloc] init];
            NSString *cacheDir = NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES)[0];
            NSString *filePath = [cacheDir stringByAppendingPathComponent:@"contactsT.sqlite"];
            
            shareDBManager.queue = [FMDatabaseQueue databaseQueueWithPath:filePath];
        }
    });
    return shareDBManager;
}

-(BOOL)creatTable
{
 
    __block BOOL flag;
    [self.queue inDatabase:^(FMDatabase *db) {
        NSString *creatTableSql = [NSString stringWithFormat:@"create table if not exists cantacts('name' TEXT,'number' TEXT,'pinyin' TEXT)"];
        flag = [db executeUpdate:creatTableSql];
    }];
    return flag;
}


-(void)insert:(NSArray *)dataArray
{
    if ([self creatTable]) {
        
        [self.queue inTransaction:^(FMDatabase *db, BOOL *rollback) {
            
            for (int i = 0; i < dataArray.count; i++)
            {
                NSString *name =dataArray[i][@"name"];
                NSString *number = dataArray[i][@"number"];
                NSString *pinyin = [NSString transformToPinyin:name];
                NSString *insertSql = [NSString stringWithFormat:@"insert into cantacts (name,number,pinyin) values ('%@','%@','%@')",name,number,pinyin];
                
                BOOL flag = [db executeUpdate:insertSql];
                if (flag)
                {
                    NSLog(@"insert succes");
                }
            }
            
        }];
    }
}



-(NSArray *)select:(NSString *)key
{
    
    __block  NSMutableArray *personArray = [NSMutableArray new];
    NSString *selectSql;
    if (key.length != 0 || key)
    {
        selectSql=  [NSString stringWithFormat:@"select * from cantacts where pinyin like '#%%%@%%'", key];
    }
    else{
        selectSql = [NSString stringWithFormat:@"select * from cantacts"];
    }
    
    [self.queue inDatabase:^(FMDatabase *db) {
        
            FMResultSet *set =[db executeQuery:selectSql];
            while ([set next])
            {
                person *p = [person new];
                p.name = [set stringForColumn:@"name"];
                p.number = [set stringForColumn:@"number"];
                p.pinyin = [set stringForColumn:@"pinyin"];
                [personArray addObject:p];
            }
    }];
    
    return personArray;
}

@end
