//
//  ViewController.m
//  FuzzySearch
//
//  Created by GM on 16/6/23.
//  Copyright © 2016年 GM. All rights reserved.
//

#import "ViewController.h"
#import "NSString+category.h"
#import "DBManager.h"
@interface ViewController ()<UITableViewDataSource,UITableViewDelegate,UISearchBarDelegate>
{
    UITableView *table;
    NSArray *contacts;
    NSString *tempStr;
}

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    table = [[UITableView alloc]initWithFrame:self.view.bounds];
    table.delegate = self;
    table.dataSource = self;
    [self.view addSubview:table];
    UISearchBar *search = [[UISearchBar alloc]initWithFrame:CGRectMake(0, 0, table.frame.size.width, 50)];
    search.delegate = self;
    [table setTableHeaderView:search];
    
    contacts = [[DBManager shareDBManager] select:nil];
    
    if (contacts.count < 1)
    {
        NSString *path = [[NSBundle mainBundle]pathForResource:@"contacts" ofType:@"plist"];
       [[DBManager shareDBManager] insert: [[NSArray alloc]initWithContentsOfFile:path]];
    }

    
}


-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return contacts.count;
}
-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *cellID = @"cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellID];
    if (!cell)
    {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:cellID];
    }
  
    person *p = contacts[indexPath.row];
    cell.textLabel.text = p.name;
    cell.detailTextLabel.text = p.number;

    return cell;
}

- (void)searchBar:(UISearchBar *)searchBar textDidChange:(NSString *)searchText
{

   contacts = [[DBManager shareDBManager]select:searchText];
    [table reloadData];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];

}

@end
